#ifndef _DEVICE_MANIPULATOR_H_
#define _DEVICE_MANIPULATOR_H_

#include "Thread.h"
#include "DeviceProf.h"

#define WM_DEVMAN_ENUMEND	(WM_APP)
#define WM_DEVMAN_DEVCHG	(WM_APP+1)
#define WM_DEVMAN_DELEND	(WM_APP+2)
#define WM_DEVMAN_LISTDEL	(WM_APP+3)

typedef enum _REMOVE_STATE {
	STATE_NONE,
	STATE_FAILED,
	STATE_REMOVED,
} REMOVE_STATE;
typedef struct _DISPLAY_LOG {
	tstring path;
	tstring name;
	BOOL selected;
	REMOVE_STATE state;
} DISPLAY_LOG;

class DeviceManipulator : public Thread
{
public:
	DeviceManipulator(void);
	virtual ~DeviceManipulator(void);

	BOOL Search( ENUM_CLASS c, HWND hWnd = NULL, BOOL append = FALSE );

	void SetSelect( size_t idx, BOOL bSelected ) { foundDevices[idx].selected = bSelected; };
	size_t size(void) { return foundDevices.size(); };
	DISPLAY_LOG operator[](int idx) { return foundDevices[idx]; };
	BOOL Delete( HWND hWnd = NULL );
	void SetAllowList( std::vector <tstring> list ) { allowName = list; };
	void SetDenyList( std::vector <tstring> list ) { denyName = list; };

	BOOL ApplySortedList( std::vector <tstring> newPathList );

protected:
	typedef enum _THREAD_STATE {
		FOR_NONE,
		FOR_ENUM,
		FOR_DEL,
	} THREAD_STATE;

	HWND hTargetWnd;
	ENUM_CLASS targetClass;
	std::vector <DISPLAY_LOG> foundDevices;
	THREAD_STATE threadState;
	BOOL bAppend;
	std::vector <tstring> allowName, denyName;

	void SearchOne( std::vector <DISPLAY_LOG> &log, BOOL bPresent );
	DWORD ThreadProc(void);
	DWORD EnumProc(void);
	DWORD DelProc(void);
};

#endif//_DEVICE_MANIPULATOR_H_
