#include "StdAfx.h"
#include "MessageBox.h"
#include "resource.h"
#include <windows.h>

BOOL GetDlgItemRect(HWND hDlg, int nIDDlgItem, RECT* rct)
{
	BOOL bRet = FALSE;
	POINT pt;
	HWND hWnd = GetDlgItem(hDlg, nIDDlgItem);
	if (hWnd != NULL)
	{
		bRet = GetWindowRect(hWnd, rct);
		{
			pt.x = rct->left;
			pt.y = rct->top;
			bRet = ScreenToClient(hDlg, &pt);
			rct->left = pt.x;
			rct->top = pt.y;

			pt.x = rct->right;
			pt.y = rct->bottom;
			bRet = ScreenToClient(hDlg, &pt);
			rct->right = pt.x;
			rct->bottom = pt.y;
		}
	}
	return bRet;
}

CMessageBox::CMessageBox(HWND hWnd, LPCTSTR lpszMessage, LPCTSTR lpszCaption)
{
	m_hParentWnd = hWnd;
	m_lpszMessage = lpszMessage;
	m_lpszCaption = lpszCaption;
}

CMessageBox::~CMessageBox(void)
{
}

int CMessageBox::Show()
{
	return (int)DialogBoxParam(	GetModuleHandle(NULL),
								MAKEINTRESOURCE(IDD_MSGBOX_IGNOREIGNOREALLABORT),
								m_hParentWnd,
								DialogProc,
								(LPARAM)this);
}

INT_PTR CALLBACK CMessageBox::DialogProc(
											HWND hwndDlg,  // _CAO{bNX̃nh
											UINT uMsg,     // bZ[W
											WPARAM wParam, // ŏ̃bZ[Wp[^
											LPARAM lParam  // 2 Ԗڂ̃bZ[Wp[^
)
{
	CMessageBox *owner;
	RECT rect, rectText, rectDlg, rectCtl;
	INT_PTR nResult;

	switch (uMsg)
	{
	case WM_INITDIALOG:
		{
			HFONT hFont = (HFONT)SendMessage( hwndDlg, WM_GETFONT, 0, 0 );

			owner = (CMessageBox*)lParam;
			GetDlgItemRect( hwndDlg, IDC_MESSAGE, &rect );
			GetWindowRect( hwndDlg, &rectDlg );
			HDC hdc = GetDC( hwndDlg );
			SelectObject( hdc, hFont );
			rectText = rect;
			DrawText( hdc, owner->m_lpszMessage, (int)_tcslen(owner->m_lpszMessage), &rectText, DT_CALCRECT );
			if ( ( (rectText.right - rectText.left) - (rect.right - rect.left) ) > 0 ) {
				MoveWindow( hwndDlg, rectDlg.left, rectDlg.top, ( rectDlg.right - rectDlg.left ) + ( (rectText.right - rectText.left) - (rect.right - rect.left) ), (rectDlg.bottom - rectDlg.top), TRUE );
				MoveWindow( GetDlgItem( hwndDlg, IDC_MESSAGE ), rect.left, rect.top, rectText.right - rectText.left, rectText.bottom - rectText.top, TRUE );

				GetDlgItemRect( hwndDlg, IDC_BTN_IGNORE, &rectCtl );
				MoveWindow( GetDlgItem( hwndDlg, IDC_BTN_IGNORE ), rectCtl.left + ( (rectText.right - rectText.left) - (rect.right - rect.left) ), rectCtl.top, rectCtl.right - rectCtl.left, rectCtl.bottom - rectCtl.top, TRUE );
				GetDlgItemRect( hwndDlg, IDC_BTN_ABORT, &rectCtl );
				MoveWindow( GetDlgItem( hwndDlg, IDC_BTN_ABORT ), rectCtl.left + ( (rectText.right - rectText.left) - (rect.right - rect.left) ), rectCtl.top, rectCtl.right - rectCtl.left, rectCtl.bottom - rectCtl.top, TRUE );
				GetDlgItemRect( hwndDlg, IDC_BTN_IGNOREALL, &rectCtl );
				MoveWindow( GetDlgItem( hwndDlg, IDC_BTN_IGNOREALL ), rectCtl.left + ( (rectText.right - rectText.left) - (rect.right - rect.left) ), rectCtl.top, rectCtl.right - rectCtl.left, rectCtl.bottom - rectCtl.top, TRUE );
			}

			SetWindowText( GetDlgItem( hwndDlg, IDC_MESSAGE ), owner->m_lpszMessage );
			SetWindowText( hwndDlg, owner->m_lpszCaption );
		}
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		nResult = -1;
		switch(LOWORD(wParam))
		{
		case IDC_BTN_IGNORE:
			nResult = IDIGNORE;
			break;
		case IDC_BTN_ABORT:
			nResult = IDABORT;
			break;
		case IDC_BTN_IGNOREALL:
			nResult = IDIGNOREALL;
			break;
		}
		if ( nResult == - 1 ) break;

		EndDialog(hwndDlg, nResult);
		return (INT_PTR)TRUE;
	}
	return (INT_PTR)FALSE;

}
