#include "StdAfx.h"
#include "PrivateProf.h"

PrivateProfile::PrivateProfile( TCHAR *ext )
{
	TCHAR temp[_MAX_PATH];
	TCHAR drive[_MAX_DRIVE], dir[_MAX_DIR];

	GetModuleFileName( NULL, temp, _MAX_PATH );
	_tsplitpath_s( temp, drive, _MAX_DRIVE, dir, _MAX_DIR, appName, _MAX_PATH, NULL, 0 );

	size_t lenfname = _tcslen( appName );
	if ( ( lenfname > 2 ) && ( _tcscmp( appName + lenfname - 2, _T("64") ) == 0 ) ) {
		appName[ lenfname - 2 ] = 0;
	}

#ifndef _DEBUG
	_tmakepath_s( profName, drive, dir, appName, ext );
#else
	GetCurrentDirectory( _MAX_PATH, profName );
	_tcscat_s( profName, MAX_PATH, _T("\\") );
	_tcscat_s( profName, MAX_PATH, appName );
	_tcscat_s( profName, MAX_PATH, ext );
#endif
}

PrivateProfile::~PrivateProfile(void)
{
}

BOOL PrivateProfile::WriteInt( UINT value, UINT def, TCHAR *key )
{
	BOOL bRet = TRUE;

	if ( value != GetPrivateProfileInt( appName, key, def, profName ) ) {
		TCHAR temp[256];
		_stprintf_s( temp, _countof(temp), _T("%d"), value );
		bRet = WritePrivateProfileString( appName, key, temp, profName );
	}

	return bRet;
}

BOOL PrivateProfile::WriteString( const TCHAR *value, TCHAR *def, TCHAR *key )
{
	BOOL bRet = TRUE;
	TCHAR *temp = NULL;
	int n = 0;
	DWORD dwRet;

	do {
		if ( temp ) {
			delete[] temp;
		}
		n += 1024;
		temp = new TCHAR[n];
		dwRet = GetPrivateProfileString( appName, key, def, temp, n, profName );
	} while( ( dwRet + 1 ) == n );

	if ( _tcscmp( value, temp ) != 0 ) {
		bRet = WritePrivateProfileString( appName, key, value, profName );
	}
	delete[] temp;

	return bRet;
}

